<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { computed, inject, ref } from 'vue';
import { storeToRefs } from 'pinia';
import { usePreviewStore } from '@/stores/preview';
import CopyModal from '@/components/preview/shared/CopyModal.vue';
import Comments from '@/components/preview/shared/CommentSidebar.vue';
import Post from '@/components/preview/timeline/Post.vue';
import Modal from '@/components/general/Modal.vue';

const store = usePreviewStore();
const { style, data, headline, subheadline, postIndex, isExport } = storeToRefs(store);

const configuration = inject<any>('configuration');

const isCopyModalOpen = ref(false);
const showCopyModal = (value: boolean) => {
    isCopyModalOpen.value = value;
};

const close = () => {
    postIndex.value = -1;
};

const lineStyle = computed(() => {
    return `solid ${style.value.lineSize}px ${style.value.lineColor}80`;
});

const lineMargin = computed(() => {
    return (-style.value.lineSize + 2) + "px";
});

const getFullContainerWidth = computed(() => {
    const count = data.value.length;
    const elementWidth = style.value.elementWidth - 50;
    return (count * elementWidth + 100) + "px";
});

const isHeadlineModalOpen = ref(false);
const showHeadlineModal = (value: boolean) => {
    isHeadlineModalOpen.value = value;
}

const isSubHeadlineModalOpen = ref(false);
const showSubHeadlineModal = (value: boolean) => {
    isSubHeadlineModalOpen.value = value;
}


</script>
<template>
    <div :class="style?.font ? style.font : ''" class="h-[calc(100dvh-80px)] min-w-screen"
        :style="[{ '--lineStyle': lineStyle }, { '--lineMargin': lineMargin }]">
        <nav class="bg-white min-h-20 max-h-20 h-20 flex flex-row">
            <div class="pl-7 h-20 pt-5">
                <div :class="['select-none', style?.font ? style.font : '']">
                    <Tooltip :tooltip="headline" :offset="10" width="max-w-96">
                        <div class="text-2xl line-clamp-1 text-ellipsis w-full h-6">{{ headline }}</div>
                    </Tooltip>
                    <div class="w-fit">
                        <Tooltip :tooltip="subheadline" placement="bottom" width="max-w-96">
                            <div class="line-clamp-1 text-ellipsis h-6">{{ subheadline }}</div>
                        </Tooltip>
                    </div>
                </div>
            </div>
            <div class="ml-auto min-w-20px p-4 pr-7" v-if="!isExport">
                <Tooltip :tooltip="$t('adminMenu.copy.label')">
                    <button
                        class="size-12 hover:bg-gray-200 text-gray-500 rounded-md block text-center align-middle leading-[48px] text-2xl hover:no-underline"
                        @click="showCopyModal(true)"><i class="ri-file-copy-line leading-12 align-middle"></i></button>
                </Tooltip>
                <CopyModal v-if="isCopyModalOpen" @close="showCopyModal(false)" />
            </div>
        </nav>
        <div id="content" class="h-full overflow-auto"
            :style="{ background: style != null && style.backgroundImage != null ? `url(${configuration.apiServer}` + style.backgroundImage + ')' : (style != null && style.backgroundColor != null ? style.backgroundColor : 'white') }">
            <ul class="flex flex-row flex-nowrap top-1/2 absolute h-1 min-w-screen pt-9 w-full">
                <div class="timeline-line-extend h-0 grow min-w-0"></div>
            </ul>
            <ul class="flex flex-row flex-nowrap w-full relative gap-2">
                <li class="w-16 max-w-16 min-w-16 h-0"></li>
                <Post :post="element" :postIndex="index" v-for="(element, index) in data" />
            </ul>
            <Comments v-if="postIndex >= 0" @close="close" />
        </div>
        <Modal v-if="isHeadlineModalOpen" @close="showHeadlineModal(false)" :labelCancel="$t('general.buttons.close')">
            <div class="text-xl" v-html="headline"></div>
        </Modal>
        <Modal v-if="isSubHeadlineModalOpen" @close="showSubHeadlineModal(false)"
            :labelCancel="$t('general.buttons.close')">
            <div class="text-lg" v-html="subheadline"></div>
        </Modal>
    </div>
</template>
<style scoped>
.timeline-line-extend {
    margin-top: var(--lineMargin);
    border: var(--lineStyle);
}
</style>
